#ifndef LABS_TREES_TREES_HPP
#define LABS_TREES_TREES_HPP

#include <ostream>

struct Node {
	int value;
	Node* left = nullptr;
	Node* right = nullptr;

	inline bool isLeaf() const {
		return left == nullptr && right == nullptr;
	}
};

// unbalanced
void add_node(Node* root, int newValue);
bool search(const Node* root, int searchValue);

// utility methods
void print_tree(std::ostream& out, Node* root, int depth=0);
void print_tree_dia(std::ostream& out, Node* root);

#endif // LABS_TREES_TREES_HPP